diff --git a/configure.ac b/configure.ac
index a285324..b7d7f3b 100644
--- a/configure.ac
+++ b/configure.ac
@@ -106,12 +106,16 @@ PKG_CHECK_MODULES(ANTHY,[anthy >= $ANTHY_VERSION])
 
 # Check gtk2
 PKG_CHECK_MODULES(GTK2, [gtk+-2.0 >= 2.8.0],
-                        [HAS_GTK=yes],
-                        [HAS_GTK=no])
+                        [HAS_GTK2=yes],
+                        [HAS_GTK2=no])
 
-AM_CONDITIONAL(SCIM_BUILD_HELPER, [test "$HAS_GTK" = "yes"])
+PKG_CHECK_MODULES(GTK3, [gtk+-3.0 >= 3.0.0],
+                        [HAS_GTK3=yes],
+                        [HAS_GTK3=no])
 
-if test "$HAS_GTK" = "yes"; then
+AM_CONDITIONAL(SCIM_BUILD_HELPER, [test "$HAS_GTK2" = "yes" -o "$HAS_GTK3" = "yes"])
+
+if test "$HAS_GTK2" = "yes" -o "$HAS_GTK3" = "yes"; then
   SCIM_BUILD_HELPER=1
 else
   SCIM_BUILD_HELPER=0
@@ -133,6 +137,61 @@ AC_ARG_ENABLE(debug,
 	       *) AC_MSG_ERROR(bad value ${enableval} for --enable-debug) ;;
        	      esac],[debug=no])
 
+#AC_ARG_WITH([gtk-version],
+#    [AS_HELP_STRING([--with-gtk-version=2 or 3],
+#        [Select gtk version if both gtk2 and gtk3 are available (default is 3)]),
+#	[WANT_GTK_VERSION=$withval],
+#    [WANT_GTK_VERSION=3])
+
+AC_ARG_WITH([gtk-version],
+    [--with-gtk-version=2 or 3		Select gtk version if both gtk2 and gtk3 are available (default is 3)],
+	[WANT_GTK_VERSION=$withval],
+    [WANT_GTK_VERSION=3])
+
+if test "$HAS_GTK3" = "yes" -a "$HAS_GTK2" = "yes"; then
+  if test "$WANT_GTK_VERSION" = "2"; then
+    USE_GTK_VERSION="2"
+  else
+    USE_GTK_VERSION="3"
+  fi
+elif test "$HAS_GTK3" = "yes"; then
+  USE_GTK_VERSION="3"
+elif test "$HAS_GTK2" = "yes"; then
+  USE_GTK_VERSION="2"
+fi
+
+if test "$USE_GTK_VERSION" = "3"; then
+  HAS_GTK=yes
+  GTK_LIBDIR=$GTK3_LIBDIR
+  GTK_VERSION=$GTK3_VERSION
+  GTK_MAJOR_VERSION=3
+  GTK_BINARY_VERSION=$GTK3_BINARY_VERSION
+  GTK_CFLAGS=$GTK3_CFLAGS
+  GTK_LIBS=$GTK3_LIBS
+  AC_SUBST(GTK_LIBDIR)
+  AC_SUBST(GTK_VERSION)
+  AC_SUBST(GTK_MAJOR_VERSION)
+  AC_SUBST(GTK_BINARY_VERSION)
+  AC_SUBST(GTK_CFLAGS)
+  AC_SUBST(GTK_LIBS)
+elif test "$USE_GTK_VERSION" = "2"; then
+  HAS_GTK=yes
+  GTK_LIBDIR=$GTK2_LIBDIR
+  GTK_VERSION=$GTK2_VERSION
+  GTK_MAJOR_VERSION=2
+  GTK_BINARY_VERSION=$GTK2_BINARY_VERSION
+  GTK_CFLAGS=$GTK2_CFLAGS
+  GTK_LIBS=$GTK2_LIBS
+  AC_SUBST(GTK_LIBDIR)
+  AC_SUBST(GTK_VERSION)
+  AC_SUBST(GTK_MAJOR_VERSION)
+  AC_SUBST(GTK_BINARY_VERSION)
+  AC_SUBST(GTK_CFLAGS)
+  AC_SUBST(GTK_LIBS)
+else
+  HAS_GTK=no
+fi
+
 if test "x$debug" = "xyes"; then
   test "$cflags_set" = set || CFLAGS="$CFLAGS -g"
   test "$cppflags_set" = set || CPPFLAGS="$CXXFLAGS -g"
diff --git a/src/Makefile.am b/src/Makefile.am
index c2ce196..50bd79f 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -138,17 +138,16 @@ else
 anthy_imengine_helper_la_SOURCES  = scim_anthy_helper.cpp
 endif
 
-anthy_imengine_helper_la_CFLAGS   = @GTK2_CFLAGS@ \
+anthy_imengine_helper_la_CFLAGS   = @GTK_CFLAGS@ \
 				    @SCIM_CFLAGS@ \
 				    @SCIM_DEBUG_FLAGS@
-anthy_imengine_helper_la_CXXFLAGS = @GTK2_CFLAGS@ \
+anthy_imengine_helper_la_CXXFLAGS = @GTK_CFLAGS@ \
 				    @SCIM_CFLAGS@ \
 				    @SCIM_DEBUG_FLAGS@
 anthy_imengine_helper_la_LDFLAGS  = -avoid-version \
                                     -rpath $(setupmoduledir) \
                                     -module \
 				    @LIBTOOL_EXPORT_OPTIONS@ \
-				    @GTK2_LIBS@ \
 				    @INTLLIBS@ \
 				    @SCIM_LIBS@ \
 				    @SCIM_GTKUTILS_LIBS@
diff --git a/src/scim_anthy_color_button.cpp b/src/scim_anthy_color_button.cpp
index 841c9aa..7606523 100644
--- a/src/scim_anthy_color_button.cpp
+++ b/src/scim_anthy_color_button.cpp
@@ -58,9 +58,14 @@ typedef enum
 static void     scim_anthy_color_button_class_init     (ScimAnthyColorButtonClass *klass);
 static void     scim_anthy_color_button_init           (ScimAnthyColorButton      *object);
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+static void     scim_anthy_color_button_destroy (GtkWidget *object);
+static gboolean scim_anthy_color_button_draw (GtkWidget *widget, cairo_t *cr);
+#else
 static void     scim_anthy_color_button_destroy        (GtkObject      *object);
 static gboolean scim_anthy_color_button_expose         (GtkWidget      *widget,
 							GdkEventExpose *eevent);
+#endif
 static gboolean scim_anthy_color_button_button_press   (GtkWidget      *widget,
 							GdkEventButton *bevent);
 static gboolean scim_anthy_color_button_button_release (GtkWidget      *widget,
@@ -100,7 +105,6 @@ scim_anthy_color_button_get_type (void)
 static void
 scim_anthy_color_button_class_init (ScimAnthyColorButtonClass *klass)
 {
-    GtkObjectClass *gtk_object_class = GTK_OBJECT_CLASS (klass);
     GtkWidgetClass *widget_class     = GTK_WIDGET_CLASS (klass);
   
     parent_class = (GtkDrawingAreaClass *) g_type_class_peek_parent (klass);
@@ -114,9 +118,15 @@ scim_anthy_color_button_class_init (ScimAnthyColorButtonClass *klass)
   		  g_cclosure_marshal_VOID__VOID,
   		  G_TYPE_NONE, 0);
   
+#if GTK_CHECK_VERSION(3, 0, 0)
+    widget_class->destroy = scim_anthy_color_button_destroy;
+    widget_class->draw = scim_anthy_color_button_draw;
+#else
+    GtkObjectClass *gtk_object_class = GTK_OBJECT_CLASS (klass);
     gtk_object_class->destroy          = scim_anthy_color_button_destroy;
-  
     widget_class->expose_event         = scim_anthy_color_button_expose;
+#endif
+  
     widget_class->button_press_event   = scim_anthy_color_button_button_press;
     widget_class->button_release_event = scim_anthy_color_button_button_release;
 }
@@ -125,8 +135,13 @@ static void
 scim_anthy_color_button_init (ScimAnthyColorButton *object)
 {
     /*set default color */ 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gdk_rgba_parse (&object->fg_color, "#000000");
+    gdk_rgba_parse (&object->bg_color, "#ffffff");
+#else
     gdk_color_parse ("#000000", &object->fg_color);
     gdk_color_parse ("#ffffff", &object->bg_color);
+#endif
 
     gtk_widget_add_events (GTK_WIDGET (object),
                     GDK_BUTTON_PRESS_MASK |
@@ -135,7 +150,11 @@ scim_anthy_color_button_init (ScimAnthyColorButton *object)
 
 
 static void
+#if GTK_CHECK_VERSION(3, 0, 0)
+scim_anthy_color_button_destroy (GtkWidget *object)
+#else
 scim_anthy_color_button_destroy (GtkObject *object)
+#endif
 {
     ScimAnthyColorButton *button = SCIM_ANTHY_COLOR_BUTTON (object);
 
@@ -150,19 +169,38 @@ scim_anthy_color_button_destroy (GtkObject *object)
         button->swap_icon = NULL;
     }
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GTK_WIDGET_CLASS (parent_class)->destroy (object);
+#else
     GTK_OBJECT_CLASS (parent_class)->destroy (object);
+#endif
 }
 
 static void
 scim_anthy_color_button_draw_rect (ScimAnthyColorButton *button,
+#if GTK_CHECK_VERSION(3, 0, 0)
+                             GdkWindow      *drawable,
+                             cairo_t        *cr,
+#else
                              GdkDrawable    *drawable,
                              GdkGC          *gc,
+#endif
                              gint            x,
                              gint            y,
                              gint            width,
                              gint            height,
-                             GdkColor        *color)
+#if GTK_CHECK_VERSION(3, 0, 0)
+                             GdkRGBA         *color
+#else
+                             GdkColor        *color
+#endif
+                             )
 {
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gdk_cairo_set_source_rgba (cr, color);
+    cairo_rectangle (cr, x, y, width, height);
+    cairo_fill (cr);
+#else
     gint    rowstride;
     guchar  r, g, b;
     gint    xx, yy;
@@ -201,23 +239,38 @@ scim_anthy_color_button_draw_rect (ScimAnthyColorButton *button,
                         GDK_RGB_DITHER_MAX,
                         button->render_buf,
                         rowstride);
+#endif
 }
 
 static gboolean
+#if GTK_CHECK_VERSION(3, 0, 0)
+scim_anthy_color_button_draw (GtkWidget      *widget,
+                          cairo_t *cr)
+#else
 scim_anthy_color_button_expose (GtkWidget      *widget,
                           GdkEventExpose *eevent)
+#endif
 {
     ScimAnthyColorButton *button = SCIM_ANTHY_COLOR_BUTTON (widget);
     gint            width, height;
     gint            swap_w = 0, swap_h = 0;
     gint            rect_w, rect_h;
   
+#if GTK_CHECK_VERSION(2, 18, 0)
+      if (!gtk_widget_is_drawable (widget))
+#else
     if (!GTK_WIDGET_DRAWABLE (widget))
+#endif
         return FALSE;
-  
+
+#if GTK_CHECK_VERSION(3, 0, 0)
+    width = gdk_window_get_width(gtk_widget_get_window (widget));
+    height = gdk_window_get_height(gtk_widget_get_window (widget));
+#else
     width  = widget->allocation.width;
     height = widget->allocation.height;
-  
+#endif
+
     /*  draw the swap colors pixbuf  */
     if (!button->swap_icon) {
         button->swap_icon
@@ -231,9 +284,14 @@ scim_anthy_color_button_expose (GtkWidget      *widget,
     }  
 
     if (swap_w < width / 2 && swap_h < height / 2) {
+#if GTK_CHECK_VERSION(3, 0, 0)
+        gdk_cairo_set_source_pixbuf (cr, button->swap_icon, width - swap_w, 0);
+        cairo_paint (cr);
+#else
         gdk_draw_pixbuf (widget->window, NULL, button->swap_icon,
                          0, 0, width - swap_w, 0, swap_w, swap_h,
                          GDK_RGB_DITHER_NORMAL, 0, 0);
+#endif
     } else {
         swap_w = swap_h = 0;
     }
@@ -249,37 +307,78 @@ scim_anthy_color_button_expose (GtkWidget      *widget,
     button->rect_width  = rect_w;
     button->rect_height = rect_h;
   
-  
     /*  draw the background area  */
     scim_anthy_color_button_draw_rect (button,
+#if GTK_CHECK_VERSION(2, 14, 0)
+                                 gtk_widget_get_window (widget),
+#else
                                  widget->window,
+#endif
+#if GTK_CHECK_VERSION(3, 0, 0)
+                                 cr,
+#else
                                  widget->style->fg_gc[0],
+#endif
                                  (width - rect_w),
                                  (height - rect_h),
                                  rect_w, rect_h,
                                  &button->bg_color);
   
-    gtk_paint_shadow (widget->style, widget->window, GTK_STATE_NORMAL,
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GtkStyleContext *style = gtk_widget_get_style_context(widget);
+    gtk_style_context_save (style);
+    gtk_style_context_set_state (style, GTK_STATE_FLAG_NORMAL);
+    gtk_render_frame (style, cr, width - rect_w, height - rect_h, rect_w, rect_h);
+#else
+    gtk_paint_shadow (widget->style,
+#if GTK_CHECK_VERSION(2, 14, 0)
+                      gtk_widget_get_window (widget),
+#else
+                      widget->window,
+#endif
+                      GTK_STATE_NORMAL,
                       GTK_SHADOW_IN,
                       NULL, widget, NULL,
                       (width - rect_w),
                       (height - rect_h),
                       rect_w, rect_h);
-  
+#endif 
   
     /*  draw the foreground area  */
     scim_anthy_color_button_draw_rect (button,
+#if GTK_CHECK_VERSION(2, 14, 0)
+                                 gtk_widget_get_window (widget),
+#else
                                  widget->window,
+#endif
+#if GTK_CHECK_VERSION(3, 0, 0)
+                                 cr,
+#else
                                  widget->style->fg_gc[0],
+#endif
                                  0, 0,
                                  rect_w, rect_h,
                                  &button->fg_color);
     
-    gtk_paint_shadow (widget->style, widget->window, GTK_STATE_NORMAL,
-                      GTK_SHADOW_IN,
-                      NULL, widget, NULL,
-                      0, 0,
-                      rect_w, rect_h);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    style = gtk_widget_get_style_context(widget);
+    gtk_style_context_save (style);
+    gtk_style_context_set_state (style, GTK_STATE_FLAG_NORMAL);
+    gtk_render_frame (style, cr, 0, 0, rect_w, rect_h);
+#else
+    gtk_paint_shadow (
+        widget->style, 
+#if GTK_CHECK_VERSION(2, 14, 0)
+        gtk_widget_get_window (widget),
+#else
+        widget->window,
+#endif
+        GTK_STATE_NORMAL,
+        GTK_SHADOW_IN,
+        NULL, widget, NULL,
+        0, 0,
+        rect_w, rect_h);
+#endif
   
     return TRUE;
 }
@@ -289,11 +388,16 @@ scim_anthy_color_button_target (ScimAnthyColorButton *button,
                           gint            x,
                           gint            y)
 {
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gint width = gdk_window_get_width(gtk_widget_get_window (GTK_WIDGET(button)));
+    gint height = gdk_window_get_height(gtk_widget_get_window (GTK_WIDGET(button)));
+#else
     gint width  = GTK_WIDGET (button)->allocation.width;
     gint height = GTK_WIDGET (button)->allocation.height;
+#endif
     gint rect_w = button->rect_width;
     gint rect_h = button->rect_height;
-  
+
     if (x > 0 && x < rect_w && y > 0 && y < rect_h)
         return FOREGROUND_AREA;
     else if (x > (width - rect_w)  && x < width  &&
@@ -314,7 +418,11 @@ scim_anthy_color_button_open_color_dialog (ScimAnthyColorButton *button, gboolea
 {
     GtkWidget *dialog;
     const gchar *title;
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GdkRGBA *color;
+#else
     GdkColor *color;
+#endif
     gint result;
   
     title = fg ? _("Foreground color") : _("Background color");
@@ -322,16 +430,38 @@ scim_anthy_color_button_open_color_dialog (ScimAnthyColorButton *button, gboolea
     
     dialog = gtk_color_selection_dialog_new (title);
 
-    gtk_color_selection_set_current_color (GTK_COLOR_SELECTION (GTK_COLOR_SELECTION_DIALOG (dialog)->colorsel),
-                                           color);
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gtk_color_selection_set_current_rgba (
+        GTK_COLOR_SELECTION (gtk_color_selection_dialog_get_color_selection (GTK_COLOR_SELECTION_DIALOG (dialog))),
+        color);
+#else
+    gtk_color_selection_set_current_color (
+#if GTK_CHECK_VERSION(2, 14, 0)
+        GTK_COLOR_SELECTION (gtk_color_selection_dialog_get_color_selection (GTK_COLOR_SELECTION_DIALOG (dialog))),
+#else
+        GTK_COLOR_SELECTION (GTK_COLOR_SELECTION_DIALOG (dialog)->colorsel),
+#endif
+        color);
+#endif
     gtk_widget_show (dialog);
 
     result = gtk_dialog_run (GTK_DIALOG (dialog));
 
     switch (result) {
         case GTK_RESPONSE_OK:
-            gtk_color_selection_get_current_color (GTK_COLOR_SELECTION (GTK_COLOR_SELECTION_DIALOG (dialog)->colorsel),
-                                                   color);
+#if GTK_CHECK_VERSION(3, 0, 0)
+            gtk_color_selection_get_current_rgba (
+                GTK_COLOR_SELECTION (gtk_color_selection_dialog_get_color_selection (GTK_COLOR_SELECTION_DIALOG (dialog))),
+                color);
+#else
+            gtk_color_selection_get_current_color (
+#if GTK_CHECK_VERSION(2, 14, 0)
+                GTK_COLOR_SELECTION (gtk_color_selection_dialog_get_color_selection (GTK_COLOR_SELECTION_DIALOG (dialog))),
+#else
+                GTK_COLOR_SELECTION (GTK_COLOR_SELECTION_DIALOG (dialog)->colorsel),
+#endif
+                color);
+#endif
             g_signal_emit (button, button_signals[COLOR_CHANGED], 0);
             break;
         default:
@@ -345,6 +475,11 @@ scim_anthy_color_button_open_color_dialog (ScimAnthyColorButton *button, gboolea
 static void
 scim_anthy_color_button_swap_color (ScimAnthyColorButton *button)
 {
+#if GTK_CHECK_VERSION(3, 0, 0)
+    GdkRGBA tmp = button->fg_color;
+    button->fg_color = button->bg_color;
+    button->bg_color = tmp;
+#else
     GdkColor tmp;
     tmp.red   = button->fg_color.red;
     tmp.green = button->fg_color.green;
@@ -357,6 +492,7 @@ scim_anthy_color_button_swap_color (ScimAnthyColorButton *button)
     button->bg_color.red   = tmp.red;
     button->bg_color.green = tmp.green;
     button->bg_color.blue  = tmp.blue;
+#endif
     g_signal_emit (button, button_signals[COLOR_CHANGED], 0);
 }
 
@@ -447,14 +583,29 @@ scim_anthy_color_button_get_colors (ScimAnthyColorButton *button,
 
     g_snprintf (fg_color_str, G_N_ELEMENTS (fg_color_str),
                 "#%02X%02X%02X", 
+#if GTK_CHECK_VERSION(3, 0, 0)
+                static_cast<unsigned int>(255*button->fg_color.red),
+                static_cast<unsigned int>(255*button->fg_color.green),
+                static_cast<unsigned int>(255*button->fg_color.blue)
+#else
                 ((button->fg_color.red)>>8),
                 ((button->fg_color.green)>>8),
-                ((button->fg_color.blue)>>8));
+                ((button->fg_color.blue)>>8)
+#endif
+                );
     g_snprintf (bg_color_str, G_N_ELEMENTS (bg_color_str),
                 "#%02X%02X%02X", 
+#if GTK_CHECK_VERSION(3, 0, 0)
+                static_cast<unsigned int>(255*button->bg_color.red),
+                static_cast<unsigned int>(255*button->bg_color.green),
+                static_cast<unsigned int>(255*button->bg_color.blue)
+#else
                 ((button->bg_color.red)>>8),
                 ((button->bg_color.green)>>8),
-                ((button->bg_color.blue)>>8));
+                ((button->bg_color.blue)>>8)
+#endif
+                );
+
     *fg_value = String (fg_color_str); 
     *bg_value = String (bg_color_str); 
 
@@ -466,6 +617,10 @@ scim_anthy_color_button_set_colors (ScimAnthyColorButton *button,
 				    const String &fg_value,
 				    const String &bg_value)
 {
+#if GTK_CHECK_VERSION(3, 0, 0)
+    gdk_rgba_parse (&button->fg_color, fg_value.c_str()); 
+    gdk_rgba_parse (&button->bg_color, bg_value.c_str()); 
+#else
     GdkColor fg_color, bg_color;
     gdk_color_parse (fg_value.c_str (), &fg_color);
     gdk_color_parse (bg_value.c_str (), &bg_color);
@@ -476,6 +631,7 @@ scim_anthy_color_button_set_colors (ScimAnthyColorButton *button,
     button->bg_color.red   = bg_color.red;
     button->bg_color.green = bg_color.green;
     button->bg_color.blue  = bg_color.blue;
+#endif
 
     return TRUE;
 }
diff --git a/src/scim_anthy_color_button.h b/src/scim_anthy_color_button.h
index f55083a..8d96ae7 100644
--- a/src/scim_anthy_color_button.h
+++ b/src/scim_anthy_color_button.h
@@ -53,8 +53,13 @@ struct _ScimAnthyColorButton
   gint             rect_height;
   gint             click_target;
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+  GdkRGBA          fg_color;
+  GdkRGBA          bg_color;
+#else
   GdkColor         fg_color;
-  GdkColor	   bg_color;
+  GdkColor	       bg_color;
+#endif
 };
 
 struct _ScimAnthyColorButtonClass
diff --git a/src/scim_anthy_helper.cpp b/src/scim_anthy_helper.cpp
index 11955d8..196c542 100644
--- a/src/scim_anthy_helper.cpp
+++ b/src/scim_anthy_helper.cpp
@@ -218,9 +218,9 @@ slot_imengine_event (const HelperAgent *agent, int ic,
         if (!reader.get_data (id) || !reader.get_data (time_msec))
             break;
         TimeoutContext *ctx = new TimeoutContext (ic, uuid, id);
-        guint timeout_id = gtk_timeout_add_full (time_msec,
+        guint timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT,
+												 time_msec,
                                                  timeout_func,
-                                                 NULL,
                                                  (gpointer) ctx,
                                                  timeout_ctx_destroy_func);
         timeout_ids[ic][id] = timeout_id;
@@ -234,7 +234,7 @@ slot_imengine_event (const HelperAgent *agent, int ic,
             timeout_ids[ic].find (id) != timeout_ids[ic].end ())
         {
             guint tid = timeout_ids[ic][id];
-            gtk_timeout_remove (tid);
+            g_source_remove (tid);
         }
         break;
     }
@@ -406,8 +406,8 @@ run (const String &display, const ConfigPointer &config)
     char **argv = new char * [4];
     int    argc = 3;
 
-    argv [0] = "anthy-imengine-helper";
-    argv [1] = "--display";
+    argv [0] = const_cast<char*> ("anthy-imengine-helper");
+    argv [1] = const_cast<char*> ("--display");
     argv [2] = const_cast<char *> (display.c_str ());
     argv [3] = 0;
  
@@ -622,11 +622,17 @@ AnthyHelper::init (const ConfigPointer &config, const char *dsp)
     if (m_helper_window == NULL)
         return;
     gtk_window_set_default_size (GTK_WINDOW (m_helper_window), 100, 20);
+	/*
     gtk_window_set_policy (GTK_WINDOW (m_helper_window),
                            TRUE, TRUE, FALSE);
+	*/
     gtk_window_set_resizable (GTK_WINDOW (m_helper_window), FALSE);
 
+#if GTK_CHECK_VERSION(3, 0, 0)
+    m_helper_vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
+#else
     m_helper_vbox = gtk_vbox_new (FALSE, 0);
+#endif
     if (m_helper_vbox == NULL)
         return;
     gtk_container_add (GTK_CONTAINER (m_helper_window),
@@ -652,7 +658,11 @@ AnthyHelper::init (const ConfigPointer &config, const char *dsp)
 
     // lookup table
     m_lookup_table_visible = false;
+#if GTK_CHECK_VERSION(3, 0, 0)
+    m_lookup_table_vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
+#else
     m_lookup_table_vbox = gtk_vbox_new (TRUE, 0);
+#endif
     if (m_lookup_table_vbox == NULL)
         return;
     gtk_box_pack_end (GTK_BOX(m_helper_vbox),
@@ -666,8 +676,10 @@ AnthyHelper::init (const ConfigPointer &config, const char *dsp)
     if (m_note_window == NULL)
         return;
     gtk_window_set_default_size (GTK_WINDOW (m_note_window), 100, 20);
+	/*
     gtk_window_set_policy (GTK_WINDOW (m_note_window),
                            TRUE, TRUE, FALSE);
+	*/
     gtk_window_set_resizable (GTK_WINDOW (m_note_window), FALSE);
 
     m_note_event_box = gtk_event_box_new ();
@@ -1027,7 +1039,11 @@ AnthyHelper::hide_note ()
 
     m_note_visible = false;
 
+#if GTK_CHECK_VERSION(2, 24, 0)
+    gtk_widget_hide (m_note_window);
+#else
     gtk_widget_hide_all (m_note_window);
+#endif
 }
 
 void
diff --git a/src/scim_anthy_prefs.cpp b/src/scim_anthy_prefs.cpp
index 91aa8c0..49765e8 100644
--- a/src/scim_anthy_prefs.cpp
+++ b/src/scim_anthy_prefs.cpp
@@ -766,7 +766,7 @@ StringConfigData config_keyboards_edit [] =
         SCIM_ANTHY_CONFIG_RECONVERT_KEY_DEFAULT,
         N_("Reconvert"),
         N_("Select reconvert keys"),
-        N_("The key events to reconvert the commited string in selection. "),
+        N_("The key events to reconvert the committed string in selection. "),
         NULL,
         false,
     },
